{{- if and .Values.isProdMode .Values.isWatcherInstalled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "k8s-bench.fullname" . }}-job-watcher
  labels:
    {{- include "k8s-bench.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "k8s-bench.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "k8s-bench.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "k8s-bench.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      volumes:
        - name: ingress-config
          configMap:
            name: {{ include "k8s-bench.fullname" . }}-ingress-config
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          volumeMounts:
            - name: ingress-config
              mountPath: /home/craft/k8s-bench/ingress-config.json
              subPath: ingress-config.json
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: NODE_ENV
              value: {{ .Values.envVars.nodeEnv }}
            - name: ERPNEXT_VERSION
              value: {{ .Values.envVars.erpnextVersion }}
            - name: ERPNEXT_NAMESPACE
              value: {{ .Values.envVars.erpnextNamespace }}
            - name: PVC_NAME
              value: {{ .Values.envVars.pvc }}
            - name: ERPNEXT_HELM_RELEASE
              value: {{ .Values.envVars.helmReleaseName }}
            - name: BENCH_UID
              value: {{ .Values.envVars.benchUid }}
            - name: BENCH_SECRET
              valueFrom:
                secretKeyRef:
                  name: {{ include "k8s-bench.fullname" . }}-api-secret
                  key: api-secret
            - name: APP_PORT
              value: {{ .Values.envVars.eventsAppPort | quote }}
            - name: PY_IMAGE
              value: {{ .Values.envVars.pyImage }}
            - name: NGINX_IMAGE
              value: {{ .Values.envVars.nginxImage }}
            - name: MARIADB_SECRET_NAME
              value: {{ .Values.envVars.mariadbSecretName }}
            - name: DELETE_SITE_CONFIG_MAP
              value: {{ .Values.envVars.deleteSiteCMName }}
            - name: WIZARD_SCRIPT_CONFIG_MAP
              value: {{ .Values.envVars.wizardCMName }}
            - name: UPGRADE_SITE_CONFIG_MAP
              value: {{ .Values.envVars.upgradeSiteCMName }}
            - name: IMAGE_PULL_SECRET_NAME
              value: {{ .Values.envVars.imgPullSecretName }}
            - name: EVENTS_HOST
              value: {{ .Values.envVars.eventsHost }}
            - name: EVENTS_PORT
              value: {{ .Values.envVars.eventsPort | quote }}
            - name: EVENTS_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ include "k8s-bench.fullname" . }}-events-secret
                  key: events-secret
            - name: EVENTS_PROTO
              value: {{ .Values.envVars.eventsProto }}
            - name: EVENTS_USER
              value: {{ .Values.envVars.eventsUser }}
          ports:
            - name: http
              containerPort: {{ .Values.envVars.eventsAppPort }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /api/healthz
              port: http
          readinessProbe:
            httpGet:
              path: /api/healthz
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
{{- end }}
